Index: /branches/scriptchanges.new/src/lib/script_engine/script.cc
===================================================================
--- /branches/scriptchanges.new/src/lib/script_engine/script.cc	(revision 10368)
+++ /branches/scriptchanges.new/src/lib/script_engine/script.cc	(revision 10369)
@@ -111,5 +111,5 @@
    if(currentFile.length() != 0)
    {
-     printf("SCRIPT %s : ERROR: Could not load %s because an other file is already loaded: %s\n",currentFile.c_str(),filename.c_str(), currentFile.c_str());
+     printf("ERROR IN SCRIPT %s :   Could not load %s because an other file is already loaded: %s\n",currentFile.c_str(),filename.c_str(), currentFile.c_str());
      return false;
     }
@@ -128,5 +128,4 @@
      else
      {
-       printf("SCRIPT %s : ERROR: while loading file %s: \n",currentFile.c_str(),filename.c_str());
        reportError(error);
      }
@@ -135,9 +134,8 @@
    else
    {
-     printf("SCRIPT %s : ERROR: while loading file %s: \n",currentFile.c_str(),filename.c_str());
      reportError(error);
    }
 
-   printf("SCRIPT : ERROR: while loading file %s \n",filename.c_str());
+   printf("ERROR IN SCRIPT:  Could not load file %s \n",filename.c_str());
    return false;
  }
@@ -166,6 +164,8 @@
         tmpObj.name = objectName;
         registeredObjects.push_back(tmpObj);
-     }
-   }
+        return;
+     }
+   }
+   printf("ERROR IN SCRIPT %s: Could not add %s of class %s\n",this->currentFile.c_str(),objectName.c_str(),className.c_str());
  }
 
@@ -188,6 +188,8 @@
         tmpObj.name = objectName;
         registeredObjects.push_back(tmpObj);
-     }
-   }
+        return;
+     }
+   }
+   printf("ERROR IN SCRIPT %s: Could not add %s of class %s\n",this->currentFile.c_str(),objectName.c_str(),className.c_str());
  }
 
@@ -229,5 +231,5 @@
    }
    else
-     printf("SCRIPT %s : ERROR: There is an other function active ( %s ) or there are unremoved return values on the stack. Please remove them first.\n",currentFile.c_str(),currentFunction.c_str());
+     printf("ERROR IN SCRIPT %s :   There is an other function active ( %s ) or there are unremoved return values on the stack. Please remove them first.\n",currentFile.c_str(),currentFunction.c_str());
    return false;
  }
@@ -256,5 +258,5 @@
    }
    else
-     PRINTF(1)("SCRIPT '%s' : no function selected.\n",currentFile.c_str());
+     PRINTF(1)("SCRIPT '%s' : No function selected.\n",currentFile.c_str());
 
    return false;
@@ -273,5 +275,5 @@
    else
    {
-     printf("SCRIPT %s : ERROR: Couldn't add parameter because the wrong function is selected: %s instead of %s\n",currentFile.c_str(), currentFunction.c_str(), toFunction.c_str());
+     printf("ERROR IN SCRIPT %s :   Couldn't add parameter because the wrong function is selected: %s instead of %s\n",currentFile.c_str(), currentFunction.c_str(), toFunction.c_str());
     return false;
    }
@@ -290,5 +292,5 @@
    else
    {
-     printf("SCRIPT %s : ERROR: Couldn't add parameter because the wrong function is selected: %s instead of %s\n",currentFile.c_str(), currentFunction.c_str(), toFunction.c_str());
+     printf("ERROR IN SCRIPT %s :   Couldn't add parameter because the wrong function is selected: %s instead of %s\n",currentFile.c_str(), currentFunction.c_str(), toFunction.c_str());
      return false;
    }
@@ -306,5 +308,5 @@
    else
    {
-     printf("SCRIPT %s : ERROR: Couldn't add parameter because the wrong function is selected: %s instead of %s\n",currentFile.c_str(), currentFunction.c_str(), toFunction.c_str());
+     printf("ERROR IN SCRIPT %s :  Couldn't add parameter because the wrong function is selected: %s instead of %s\n",currentFile.c_str(), currentFunction.c_str(), toFunction.c_str());
      return false;
    }
@@ -341,5 +343,5 @@
      }
      else
-       printf("SCRIPT %s : ERROR: Trying to retreive non bolean value\n",this->currentFile.c_str());
+       printf("ERROR IN SCRIPT %s :  Trying to retreive non bolean value\n",this->currentFile.c_str());
    }
    return returnValue;
@@ -394,5 +396,5 @@
   const char *msg = lua_tostring(luaState, -1);
   if (msg == NULL) msg = "(error with no message)\n";
-  printf("ERROR: %s\n", msg);
+  printf("ERROR IN SCRIPT %s : %s\n",currentFile.c_str(), msg);
   lua_pop(luaState, 1);
  }
Index: /branches/scriptchanges.new/src/world_entities/creatures/fps_player.cc
===================================================================
--- /branches/scriptchanges.new/src/world_entities/creatures/fps_player.cc	(revision 10368)
+++ /branches/scriptchanges.new/src/world_entities/creatures/fps_player.cc	(revision 10369)
@@ -342,4 +342,8 @@
   velocity *= 100;
 
+  if( this->bJump)
+  {
+    printf("position:( %f, %f, %f ) \n", this->getAbsCoorX(), this->getAbsCoorY(), this->getAbsCoorZ());
+  }
   if( this->getModel( 0) != NULL && this->getModel(0)->isA(InteractiveModel::staticClassID()))
   {